<?php
//----------------------------------------------------------- START DER FRITZBOX VERBINDUNG
// Fritzbox Login-Daten in klartext
$username = "FritzBox-Benutzername";
$password = "FritzBox-Kennwort";

// URL zur FRITZ!Box, um die Challenge abzurufen
$challenge_url = 'http://fritz.box/login_sid.lua?version=2';

// HTTP GET-Anfrage, um die Challenge abzurufen
$challenge_response = file_get_contents($challenge_url);

// Die Challenge aus der XML-Datei extrahieren
preg_match('/<Challenge>(.*?)<\/Challenge>/', $challenge_response, $matches);
$challenge = $matches[1];

// Zerlegen Sie die Challenge in Teile, getrennt durch "$"
$challengeParts = explode("$", $challenge);

// Extrahieren Sie die Werte
$iter1 = $challengeParts[1];
$salt1 = $challengeParts[2];
$iter2 = $challengeParts[3];
$salt2 = $challengeParts[4];

// Berechnung des Response-Wertes
$hash1 = hash_pbkdf2("sha256", $password, hex2bin($salt1), (int)$iter1, 64);
$response = $salt2 . "$" . hash_pbkdf2("sha256", hex2bin($hash1), hex2bin($salt2), (int)$iter2, 64);

// Erstellen Sie den POST-Request
$data = [
    'response' => $response,
    'username' => $username
];

// URL zur FRITZ!Box einrichten
$url = 'http://fritz.box/login_sid.lua?version=2';

// POST-Anfrage an die FRITZ!Box senden
$response = httpPost($url, $data);

// Die Session-ID aus der Antwort extrahieren
preg_match('/<SID>(.*?)<\/SID>/', $response, $matches);
$session_id = $matches[1];

// Die erhaltenen Daten anzeigen
//echo "Session-ID: " . $session_id . "<br>";

// Funktion für den HTTP POST-Request
function httpPost($url, $data) {
    $options = [
        'http' => [
            'header' => "Content-type: application/x-www-form-urlencoded\r\n",
            'method' => 'POST',
            'content' => http_build_query($data),
        ],
    ];
    $context = stream_context_create($options);
    return file_get_contents($url, false, $context);
}
//----------------------------------------------------------- ENDE DER FRITZBOX VERBINDUNG
?>